module type genletrec = sig
  type locus_t
  val genletrec_locus: (locus_t -> 'a code) -> 'a code
  val genletrec : locus_t -> 
    (('a->'b) code -> 'a code -> 'b code) -> ('a->'b) code 
end

type evod = Even | Odd


let rec sevodf self idx m n = match idx with
  | Even -> 
   .<if .~n>0 then .~(self Odd m) (.~n-1) else
   .~(if m>0 then .<.~(self Odd (m-1)) .~n>. else
      .<true>.)>.
  | Odd  -> 
   .<if .~n>0 then .~(self Even m) (.~n-1) else
   .~(if m>0 then .<.~(self Even (m-1)) .~n>. else
      .<false>.)>.



module Ex1(S:genletrec) = struct
  open S

  let mrfix : 
      (('a -> ('b->'c) code) -> ('a -> 'b code ->'c code)) -> 
        ('a -> ('b->'c) code) = 
        fun f x ->
  genletrec_locus @@ fun locus ->
  let memo = ref [] in
  let rec loop n = 
    match List.assoc n !memo with
    | x -> x
    | exception Not_found -> 
        genletrec locus (fun g y -> 
          memo := (n,g) :: !memo;
          f loop n y)
  in loop x

  let res = mrfix 
              (fun self (idx,m)-> sevodf (fun idx m -> self (idx,m)) idx m)
              (Even,1)
end

(* repeating because the types are a bit off *)

module Ex1(S: sig
  type locus_t
  val genletrec_locus: (locus_t -> 'a code) -> 'a code
  val genletrec : locus_t -> 
    ((int->bool) code -> int code -> bool code) -> (int->bool) code end) = 
  struct
  open S

  let mrfix : 
      (('a -> ('b->'c) code) -> ('a -> 'b code ->'c code)) -> 
        ('a -> ('b->'c) code) = 
        fun f x ->
  genletrec_locus @@ fun locus ->
  let memo = ref [] in
  let rec loop n = 
    match List.assoc n !memo with
    | x -> x
    | exception Not_found -> 
        genletrec locus (fun g y -> 
          memo := (n,g) :: !memo;
          f loop n y)
  in loop x

  let res = mrfix 
              (fun self (idx,m)-> sevodf (fun idx m -> self (idx,m)) idx m)
              (Even,1)
end



module GL (S: sig type a type b end) = struct
  type locus_t = {mutable ids    : (int * (S.a->S.b) code) list;
                  mutable bodies : (int * (S.a->S.b) code) list;
                }


  let genletrec_locus: (locus_t -> 'a code) -> 'a code = fun body ->
    let locus = {ids = []; bodies = []} in
    let make_def n = 
      match List.assoc n locus.bodies with
      | exception Not_found -> .<fun _ -> assert false>. 
      | x -> x in
    let body_code = ref .<assert false>. in
    let doithere ids = locus.ids <- ids; body_code := body locus in
    .<let rec g1 x = .~(make_def 1) x and g2 x = .~(make_def 2) x 
          and g3 x = .~(make_def 3) x 
          and g4 x = .~(
           doithere [(1,.<g1>.);(2,.<g2>.);(3,.<g3>.);(4,.<g4>.)];make_def 4) x 
      in
       .~(!body_code)>.
    
  let genletrec : locus_t -> 
    (('a->'b) code -> 'a code -> 'b code) -> ('a->'b) code = fun l f ->
      let ((n,id)::ids) = l.ids in
      let () = l.ids <- ids in
      let b  = .<fun x ->  .~(f id .<x>.)>. in
      let () = l.bodies <- (n,b)::l.bodies in
      id
end

let ce =
  let module M = Ex1(GL(struct type a = int type b = bool end)) in M.res;;
(*
val ce : (int -> bool) code = .<
  let rec g1_1 x_12 =
    (fun x_6  -> if x_6 > 0 then g4_4 (x_6 - 1) else g2_2 x_6) x_12
  
  and g2_2 x_11 =
    (fun x_7  -> if x_7 > 0 then g3_3 (x_7 - 1) else false) x_11
  
  and g3_3 x_10 = (fun x_8  -> if x_8 > 0 then g2_2 (x_8 - 1) else true) x_10
  
  and g4_4 x_5 =
    (fun x_9  -> if x_9 > 0 then g1_1 (x_9 - 1) else g3_3 x_9) x_5
   in g1_1>. 
*)
let true = Runcode.run ce 41;;


open Token
type state2 = S1 | S2 | S3 | S4
type ('alph,'state) automaton = 
    {finals : 'state list;
     trans  : ('state * ('alph * 'state) list) list
   }
let au3 = 
  {finals = [S1; S2; S3; S4];
   trans = [S1, [A, S2; B, S3];
            S2, [A, S3; B, S4];
            S3, [A, S4; B, S1];
            S4, [A, S1; B, S2];]
 }
;;


let makeau : (token, 'a) automaton ->
  ('a -> (token list -> bool) code) -> 'a -> token list code -> bool code =
  fun {finals;trans} self state stream ->
  let accept = List.mem state finals in 
  let next token = List.assoc token (List.assoc state trans) in
  .<match .~stream with
  | A :: r -> .~(self (next A)) r 
  | B :: r -> .~(self (next B)) r 
  | [] -> accept>.
 ;;

module Ex2(S: sig
  type locus_t
  val genletrec_locus: (locus_t -> 'a code) -> 'a code
  val genletrec : locus_t -> 
    ((token list->bool) code -> token list code -> bool code) -> 
      (token list->bool) code end) = 
  struct
  open S

  let mrfix : 
      (('a -> ('b->'c) code) -> ('a -> 'b code ->'c code)) -> 
        ('a -> ('b->'c) code) = 
        fun f x ->
  genletrec_locus @@ fun locus ->
  let memo = ref [] in
  let rec loop n = 
    match List.assoc n !memo with
    | x -> x
    | exception Not_found -> 
        genletrec locus (fun g y -> 
          memo := (n,g) :: !memo;
          f loop n y)
  in loop x

  let res = mrfix (makeau au3) S1
end

let module M = Ex2(GL(struct type a = token list type b = bool end)) in M.res;;
(*
- : (Token.token list -> bool) code = .<
let rec g1_71 x_90 =
  (fun x_76  ->
     match x_76 with
     | (Token.A )::r_77 -> g4_74 r_77
     | (Token.B )::r_78 -> g2_72 r_78
     | [] -> true) x_90

and g2_72 x_89 =
  (fun x_79  ->
     match x_79 with
     | (Token.A )::r_80 -> g3_73 r_80
     | (Token.B )::r_81 -> g1_71 r_81
     | [] -> true) x_89

and g3_73 x_88 =
  (fun x_82  ->
     match x_82 with
     | (Token.A )::r_83 -> g1_71 r_83
     | (Token.B )::r_84 -> g4_74 r_84
     | [] -> true) x_88

and g4_74 x_75 =
  (fun x_85  ->
     match x_85 with
     | (Token.A )::r_86 -> g2_72 r_86
     | (Token.B )::r_87 -> g3_73 r_87
     | [] -> true) x_75
 in g1_71>. 
*)
